Push new settings tool

pull/20/head
Botspot 5 years ago
parent 693fa8448d
commit d97c08dc4b

@ -123,19 +123,15 @@ Do you want to edit ${name}?" --timeout=10 \
;;
3)
cp -rn "${DIRECTORY}/apps/template/." "${DIRECTORY}/apps/${name}"
#find the best text editor
if [ -f /usr/bin/geany ];then
geany "${DIRECTORY}/apps/${name}/install" &
elif [ -f /usr/bin/mousepad ];then
mousepad "${DIRECTORY}/apps/${name}/install" &
elif [ -f /usr/bin/leafpad ];then
leafpad "${DIRECTORY}/apps/${name}/install" &
elif [ -f /bin/nano ];then
lxterminal --title=Nano -e "nano ${DIRECTORY}/apps/${name}/install" &
else
echo "No text editors found!"
preferrededitor="$(cat "${DIRECTORY}/data/settings/Preferred text editor")"
if [ -z "$preferrededitor" ];then
preferrededitor=geany
fi
"$preferrededitor" "${DIRECTORY}/apps/${name}/install"
output="$(yad --form --on-top \
--title="Create App: Step $step" --window-icon="${DIRECTORY}/icons/logo.png" --center --width=310 --height=300 \
--text='Now it'\''s time to make your install script. This will be executed anytime somebody clicks the Install button.
@ -162,18 +158,13 @@ A text editor should have openened and you can create your install script.' \
cp -rn "${DIRECTORY}/apps/template/." "${DIRECTORY}/apps/${name}"
#find the best text editor
if [ -f /usr/bin/geany ];then
geany "${DIRECTORY}/apps/${name}/uninstall" &
elif [ -f /usr/bin/mousepad ];then
mousepad "${DIRECTORY}/apps/${name}/uninstall" &
elif [ -f /usr/bin/leafpad ];then
leafpad "${DIRECTORY}/apps/${name}/uninstall" &
elif [ -f /bin/nano ];then
lxterminal --title=Nano -e "nano ${DIRECTORY}/apps/${name}/uninstall" &
else
echo "No text editors found!"
preferrededitor="$(cat "${DIRECTORY}/data/settings/Preferred text editor")"
if [ -z "$preferrededitor" ];then
preferrededitor=geany
fi
"$preferrededitor" "${DIRECTORY}/apps/${name}/uninstall"
output="$(yad --form --on-top \
--title="Create App: Step $step" --window-icon="${DIRECTORY}/icons/logo.png" --center --width=310 --height=300 \
--text='Now it'\''s time to make your uninstall script. This will be executed anytime somebody clicks the Uninstall button.

@ -1,5 +1,5 @@
#How often do you want to check for updates?
Always
Daily
Always
Weekly
Never

@ -1,3 +1,3 @@
#When viewing an App's details, display an Edit button. Beware that updating later will undo your edits.
Yes
No
Yes

@ -0,0 +1,3 @@
#Tired of them being sorted alphabetically? Randomizing the order will keep things fresh.
No
Yes

10
gui

@ -23,8 +23,12 @@ while true;do
APPS="$(echo "$(ls "${DIRECTORY}/apps")" | grep -v 'template')"
#APPS="$(echo "$(ls "${DIRECTORY}/apps")")"
#echo -e "$APPS\n"
#shuffle the list if enabled
if [ "$(cat "${DIRECTORY}/data/settings/Shuffle App list")" == 'Yes' ];then
APPS="$(echo "$APPS" | shuf)"
fi
APPS="$(echo "$APPS" | tr '\n' '|')"
PREIFS="$IFS"
@ -100,7 +104,7 @@ $(echo "$(cat "${DIRECTORY}/apps/${output}/description" || echo "Description una
#if already installed then no need to provide install button. And vice versa.
whichbutton="$(
if [ -f "${DIRECTORY}/data/settings/show-edit-button" ];then
if [ "$(cat "${DIRECTORY}/data/settings/Show Edit button")" == 'Yes' ];then
echo "--button=Edit!${DIRECTORY}/icons/edit.png:10"
fi
if [ ! -f "${DIRECTORY}/data/status/${output}" ];then

@ -140,7 +140,7 @@ elif [ "$1" == 'update' ];then
#copy new version to apps/
cp -rf "${DIRECTORY}/update/pi-apps/apps/${2}" "${DIRECTORY}/apps/${2}"
if [ "$installback" == 'yes' ] && [ -f "${DIRECTORY}/data/settings/reinstall-after-update" ];then
if [ "$installback" == 'yes' ] && [ "$(cat "${DIRECTORY}/data/settings/Reinstall after update")" != 'No' ];then
echo "$2 was originally installed before updating. Reinstalling the new version now."
#install it using a recursive script instance
"${DIRECTORY}/manage" install "$2"

@ -6,82 +6,117 @@ function error {
exit 1
}
#ensure settings dir exists
if [ ! -d "${DIRECTORY}/data/settings" ];then
echo "creating settings directory"
mkdir -p "${DIRECTORY}/data/settings"
#create default files inside
echo '' > "${DIRECTORY}/data/settings/reinstall-after-update"
fi
if [ ! -f ~/.local/share/applications/pi-apps-settings.desktop ];then
echo "Creating Settings menu button"
echo "[Desktop Entry]
Name=Pi Apps Settings
Comment=Configure Pi-Apps or create an App
Exec=${DIRECTORY}/settings
Icon=${DIRECTORY}/icons/logo.png
Terminal=false
Type=Application
Categories=Settings;" > ~/.local/share/applications/pi-apps-settings.desktop
fi
exitloop=''
while [ -z $exitloop ];do
#ensure settings dir exists
if [ ! -d "${DIRECTORY}/data/settings" ];then
echo "creating settings directory"
mkdir -p "${DIRECTORY}/data/settings"
#create default files inside
echo '' > "${DIRECTORY}/data/settings/reinstall-after-update"
fi
settings='show-edit-button
update-always
reinstall-after-update
'
#$1 is usually left blank. If it equals 'reset', then the settings will be reset and then the script will exit.
if [ "$1" == 'reset' ];then
#set default settings, if they don't exist
settings="$(ls "${DIRECTORY}/etc/setting-params" | tr '\n' '|')"
PREIFS="$IFS"
IFS='|'
for name in $settings
do
cat "${DIRECTORY}/etc/setting-params/${name}" | grep -v '#' | head -n1 > "${DIRECTORY}/data/settings/${name}"
done
IFS="$PREIFS"
exit 0
fi
tooltips='When viewing an App'\''s details, display an Edit button. Beware that updating will revert your edits.
Instead of checking for updates once a day, do an update check every time Pi-Apps is launched.
If the app was installed prior to updating, then automatically install it back after updating it.
'
line=1
for i in $settings
do
if [ -f "${DIRECTORY}/data/settings/${i}" ];then
truefalse='true'
else
truefalse='false'
if [ ! -f ~/.local/share/applications/pi-apps-settings.desktop ];then
echo "Creating Settings menu button"
echo "[Desktop Entry]
Name=Pi Apps Settings
Comment=Configure Pi-Apps or create an App
Exec=${DIRECTORY}/settings
Icon=${DIRECTORY}/icons/logo.png
Terminal=false
Type=Application
Categories=Settings;" > ~/.local/share/applications/pi-apps-settings.desktop
fi
LIST="${LIST}${truefalse}
$(echo "$settings" | sed -n "${line}p" )
$(echo "$tooltips" | sed -n "${line}p" )
"
line=$((line+1))
done
LIST="${LIST::-1}"
#echo "LIST: ${LIST}EOL"
output="$(echo -e "$LIST" | yad --center --title='Pi-Apps Settings' --width=310 --height=300 --no-headers \
--list --checklist --separator='\n' --window-icon="${DIRECTORY}/icons/logo.png" \
--column=:CHK --column=Name --column=tip:HD --tooltip-column=3 --print-column=2 \
--button='new app'!"${DIRECTORY}/icons/create.png":"${DIRECTORY}/createapp" \
--button=Cancel!"${DIRECTORY}/icons/exit.png":1 \
--button=Save!"${DIRECTORY}/icons/check.png":0 \
2>/dev/null)"
settings="$(ls "${DIRECTORY}/etc/setting-params" | tr '\n' '|')"
yadparams=''
PREIFS="$IFS"
IFS='|'
for name in $settings
do
params="$(cat "${DIRECTORY}/etc/setting-params/${name}" | grep -v '#')"
#create file if necessary
if [ ! -f "${DIRECTORY}/data/settings/${name}" ];then
cat "${DIRECTORY}/etc/setting-params/${name}" | grep -v '#' | head -n1 > "${DIRECTORY}/data/settings/${name}"
fi
#get current setting
curval="$(cat "${DIRECTORY}/data/settings/${name}")"
#order params, with selected option first
params="$(echo "$params" | grep -x "$curval")
$(echo "$params" | grep -v "$curval")"
params="$(echo "$params" | tr '\n' '!')"
params="${params::-1}"
tooltip="$(cat "${DIRECTORY}/etc/setting-params/${name}" | grep '#')"
tooltip="${tooltip:1}"
#echo "Params of ${name}: ${params}"
#echo "Tooltip of ${name}: ${tooltip}"
yadparams="${yadparams}
--field=${name}::CB
${params}"
done
IFS="$PREIFS"
button=$? #get exit code to determine which button was pressed
#exit if save was not clicked
[ $button -ne 0 ]&&exit 0
yadparams="$(echo "$yadparams" | tr ' ' '-')"
echo "$yadparams"
#reformat output var. Only lists items that have been enabled.
output="$(echo "$output" | sed '/^$/d')
"
output="$(yad --center --title='Pi-Apps Settings' --width=310 --height=300 \
--form --separator='\n' --window-icon="${DIRECTORY}/icons/logo.png" \
$yadparams \
--field='New App'!"${DIRECTORY}/icons/create.png":FBTN "${DIRECTORY}/createapp" \
--button='Reset'!"${DIRECTORY}/icons/backup.png"!'Reset all settings to their defaults':2 \
--button=Cancel!"${DIRECTORY}/icons/exit.png":1 \
--button=Save!"${DIRECTORY}/icons/check.png":0 \
2>/dev/null)"
echo "Output: ${output}EOO"
button=$? #get exit code to determine which button was pressed
#exit if save was not clicked
[ $button -ne 0 ]&&[ $button -ne 2 ]&&exit 0
for i in $settings
do
#if output matches current setting
if [ ! -z "$(echo "$output" | grep -x "$i")" ];then
echo "$i is enabled"
#create file
echo '' > "${DIRECTORY}/data/settings/${i}"
if [ $button -eq 2 ];then
output=''
"${0}" reset
else
echo "$i is disabled"
#delete file
rm -f "${DIRECTORY}/data/settings/${i}"
exitloop=yes
fi
done
echo "Output: ${output}EOO"
settings="$(ls "${DIRECTORY}/etc/setting-params" | tr '\n' '|')"
PREIFS="$IFS"
IFS='|'
settingnumber=1
for name in $settings
do
curval="$(echo "$output" | sed -n "${settingnumber}p")"
echo "Setting '$name' to '$curval'"
echo "$curval" > "${DIRECTORY}/data/settings/${name}"
settingnumber=$((settingnumber + 1))
done
IFS="$PREIFS"

@ -7,12 +7,39 @@ function error {
exit 1
}
#if updates not checked for today, then check for updates now
if [ ! -f "${DIRECTORY}/data/settings/update-always" ] && [ -f "${DIRECTORY}/data/last-update-check" ] && [ "$(date +%j)" == "$(cat "${DIRECTORY}/data/last-update-check")" ];then
echo "Already checked for updates today, so no need to check again.
To forcibly check for updates now, either delete ${DIRECTORY}/data/last-update-check,
enable 'update-always' in Settings,
or press any key within the next 20 seconds."
lastupdatecheck="$(cat "${DIRECTORY}/data/last-update-check")"
if [ -z $lastupdatecheck ];then
echo "Warning: ${DIRECTORY}/data/last-update-check does not exist!"
lastupdatecheck=0
fi
updateinterval="$(cat "${DIRECTORY}/data/settings/Check for updates")"
#allowed values: Always, Daily, Weekly, Never
if [ "$updateinterval" == 'Never' ];then
nocheck=1
echo ''
elif [ "$updateinterval" == 'Daily' ];then
#if updates checked today, don't check
if [ "$(date +%j)" == "$lastupdatecheck" ];then
nocheck=1
fi
elif [ "$updateinterval" == 'Weekly' ];then
#if updates checked less than 7 days ago, don't check
if [ "$(date +%j)" -le "$((lastupdatecheck + 7))" ];then
nocheck=1
fi
elif [ "$updateinterval" == 'Always' ];then
echo "Checking for updates now..."
elif [ -z "$updateinterval" ];then
echo "Something isn"\'" right. Does ${DIRECTORY}/data/settings/Check for updates exist?"
else
echo "Warning: Unrecognized update interval!"
fi
if [ $nocheck == 1 ];then
echo "Won"\'"t check for updates today, because of the update interval is set to $updateinterval in Settings.
To forcibly check for updates now, press any key within the next 20 seconds."
read -n 1 -t 20 || exit 0
echo ''
fi

Loading…
Cancel
Save